package RTBMute
{
   function RTBCC_RoomSession::receive(%this,%message)
   {
      %from = %message.attrib["from"];
      if(!%this.manifest.hasUser(%from))
         return;
      %user = %this.manifest.getByID(%from);
      %blocked = %user.blocked;
      if(%blocked)
         return;
      Parent::receive(%this,%message);
   }
   function RTBCC_RoomSessionManifestUser::render(%this)
   {
      if(%this.blocked && %this.icon !$= "user_delete")
      {
         if(!strLen(%this.previousIcon))
            %this.previousIcon=%this.icon;
         %this.icon="user_delete";
      }
      Parent::render(%this);
   }
   function RTBCC_RoomSessionManifestUser::openMenu(%this)
   {
      %this.gui_selectBox.setBitmap($RTB::Path @ "images/ui/userListSelect_d");
      
      %top = getWord(%this.gui_selectBox.getPosRelativeTo(%this.session.window.userScroll),1);
      %bottom = %top + getWord(%this.gui_selectBox.extent,1);
      %scrollExt = getWord(%this.session.window.userScroll.extent,1)-2;

      if(%top < 0)
         %this.session.window.userSwatch.resize(1,getWord(%this.session.window.userSwatch.position,1)-(%top-2),140,getWord(%this.session.window.userSwatch.extent,1));
      if(%bottom > %scrollExt)
         %this.session.window.userSwatch.resize(1,getWord(%this.session.window.userSwatch.position,1)-(%bottom-%scrollExt)-2,140,getWord(%this.session.window.userSwatch.extent,1));
         
      
      %menuItems = -1;
      %menuIcon[%menuItems++] = "comment";
      %menuText[%menuItems] = "Chat";
      %menuComm[%menuItems] = %this@".openChatWindow();";
      %menuIcon[%menuItems++] = "information";
      %menuText[%menuItems] = "Info";
      %menuComm[%menuItems] = %this@".info();";
      if(!%this.blocked)
      {
         %menuIcon[%menuItems++] = "block";
         %menuText[%menuItems] = "Block";
         %menuComm[%menuItems] = %this@".block();";
      }
      else if(%this.blocked)
      {
         %menuIcon[%menuItems++] = "block";
         %menuText[%menuItems] = "Unblock";
         %menuComm[%menuItems] = %this@".unblock();";
      }
      if(!RTBCC_Roster.hasID(%this.id) && !RTBCC_InviteRoster.hasID(%this.id))
      {
         %menuIcon[%menuItems++] = "heart_add";
         %menuText[%menuItems] = "Friend";
         %menuComm[%menuItems] = %this@".addFriend();";
      }
      if(%this.manifest.getById(RTB_ConnectClient.client_id).rank >= 1 && %this.rank < %this.manifest.getById(RTB_ConnectClient.client_id).rank)
      {
         %menuIcon[%menuItems++] = "block";
         %menuText[%menuItems] = "Kick";
         %menuComm[%menuItems] = %this@".kick();";
      }
      if(%this.manifest.getById(RTB_ConnectClient.client_id).rank >= 2 && %this.rank < %this.manifest.getById(RTB_ConnectClient.client_id).rank)
      {
         %menuIcon[%menuItems++] = "delete";
         %menuText[%menuItems] = "Ban";
         %menuComm[%menuItems] = %this@".ban();";
         
         %menuIcon[%menuItems++] = "medal_gold_3";
         %menuText[%menuItems] = "Rank";
         %menuComm[%menuItems] = %this@".changeRank();";
      }
      %menuItems++;
      
      %menuSize = (%menuItems * 20) + 4;
      
      %container = RTB_Overlay;
      %position = %this.gui_selectBox.getAbsPosition(%container);
      %menu = new GuiSwatchCtrl()
      {
         position = vectorAdd(%position,"63 22");
         extent = "66" SPC %menuSize;
         color = "0 0 0 0";
         
         user = %this;
         
         new GuiBitmapCtrl()
         {
            position = "0" SPC %menuSize - 4;
            extent = "66 4";
            
            bitmap = $RTB::Path @ "images/ui/buddyListMenuBottom";
         };
      };
      %container.add(%menu);
      %this.gui_menu = %menu;
      %this.session.gui_userMenu = %menu;
      
      for(%i=0;%i<%menuItems;%i++)
      {
         %item = new GuiBitmapCtrl()
         {
            position = "0" SPC (%i * 20);
            extent = "66 20";
            
            bitmap = $RTB::Path @ "images/ui/buddyListMenu_n";
            
            new GuiBitmapCtrl()
            {
               position = "4 2";
               extent = "16 16";
               
               bitmap = $RTB::Path @ "images/icons/" @ %menuIcon[%i];
            };
            
            new GuiMLTextCtrl()
            {
               position = "22 4";
               extent = "54 12";
               
               text = "<color:444444><font:Verdana:12>" @ %menuText[%i];
               
               selectable = false;
            };
         };
         %menu.add(%item);
         
         %mouseEvent = new GuiMouseEventCtrl()
         {
            position = "0" SPC (%i * 20);
            extent = "66 20";
            
            eventType = "UserListMenu";
            eventCallbacks = "1101000";
            
            user = %this;
            item = %item;
            command = %menuComm[%i];
         };
         %menu.add(%mouseEvent);
      }
      %this.gui_mouseEvent.extent = "129" SPC (%menuSize + 30);
      
      if(RTBCO_getPref("CC::EnableSounds"))
         alxPlay(RTBCC_TickSound);
   }
};
activatepackage(RTBMute);
function RTBCC_RoomSessionManifestUser::block(%this,%confirm)
{
   %this.closeMenu();
   
   if(!%confirm)
      RTB_ConnectClient.messageBoxYesNo("Really?","Are you sure you want to block "@%this.name@" from messaging you?",%this@".block(1);");
   else
   {
      RTBCC_Socket.blockUser(%this.id);
      
      for(%i=0;%i<RTBCC_RoomSessionManager.getCount();%i++)
      {
         if((%m=RTBCC_RoomSessionManager.getObject(%i)).manifest.hasUser(%this.id))
         {
            %u=%m.manifest.getByID(%this.id);
            %u.blocked=1;
            if(!strLen(%u.previousIcon))
               %u.previousIcon=%u.icon;
            %u.icon="user_delete";
            %u.gui_userIcon.setBitmap($RTB::Path @ "images/icons/" @ %this.icon);
         }
            
      }
   }
}
function RTBCC_RoomSessionManifestUser::unblock(%this)
{
   %this.closeMenu();
   
   RTBCC_Socket.unblockUser(%this.id);
   for(%i=0;%i<RTBCC_RoomSessionManager.getCount();%i++)
   {
      if((%m=RTBCC_RoomSessionManager.getObject(%i)).manifest.hasUser(%this.id))
      {
         %u=%m.manifest.getByID(%this.id);
         %u.blocked=0;
         if(strLen(%u.previousIcon))
            %u.icon=%u.previousIcon;
         else
            %u.icon="user";
         %u.previousIcon = "";
         %u.gui_userIcon.setBitmap($RTB::Path @ "images/icons/" @ %this.icon);
      }
         
   }
}